﻿;http://forums.purebasic.com/english/viewtopic.php?f=12&t=70581
#DWMWA_EXTENDED_FRAME_BOUNDS = 9
#CAPTUREBLT  = $40000000

Global spa.s ;savepath
Enumeration
  #c_alt
  #c_win
  #c_shift
  #c_ctrl
  #b_ok
EndEnumeration

If OpenWindow(0, 100, 200, 200, 60, "Window Cap",#PB_Window_Invisible|#PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget);,#PB_Window_BorderLess|#PB_Window_Invisible);| #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget) 
  
  If CreatePopupMenu(0) 
    MenuItem(2, "Quit") 
  EndIf  
  
  If CountProgramParameters()
    spa=ProgramParameter(0)
    Else
  spa=""
EndIf

  hicon.l=LoadIcon_(GetModuleHandle_(0),1)
  AddSysTrayIcon (1, WindowID(0), hicon)
  
  If Not RegisterHotKey_(WindowID(0),2,#MOD_WIN,#VK_SNAPSHOT)
    MessageRequester("Hotkey","Cannot register hotkey",#PB_MessageRequester_Ok )
    End
  EndIf
  
  Lib = OpenLibrary(#PB_Any, "dwmapi.dll")
  If lib
    *DwmGetWindowAttribute = GetFunction(Lib, "DwmGetWindowAttribute")
  EndIf
  
  SysTrayIconToolTip (1, "wnd cpt")
  Repeat 
    
    EventID.l = WaitWindowEvent() 
    
    Select EventID
      Case #WM_HOTKEY;If EventID =#WM_HOTKEY
        kd.l=EventwParam()
        hwnd.l=GetForegroundWindow_()
        If hwnd
          ;test for active window
          ;*m=AllocateMemory(200)
          ;GetWindowText_(hwnd,*m,200)
          ;Debug PeekS(*m) ;,#PB_Ascii)
          ;ShowMemoryViewer(*m,1024)
          ;FreeMemory(*m)
          
          If OSVersion() >= #PB_OS_Windows_Vista
            lib = OpenLibrary(#PB_Any, "UxTheme.dll")
            If lib
              *IsThemeActive = GetFunction(lib, "IsThemeActive")
              If *IsThemeActive
                Themed = CallFunctionFast(*IsThemeActive)
              EndIf   
              CloseLibrary(lib)
            EndIf
            If Themed = 1
              Lib = OpenLibrary(#PB_Any, "dwmapi.dll")
              If Lib
                *DwmIsCompositionEnabled = GetFunction(Lib, "DwmIsCompositionEnabled")
                If *DwmIsCompositionEnabled
                  CallFunctionFast(*DwmIsCompositionEnabled, @flag)
                EndIf
                If flag = 1
                  *DwmGetWindowAttribute = GetFunction(Lib, "DwmGetWindowAttribute")
                  If *DwmGetWindowAttribute                 
                    CallFunctionFast(*DwmGetWindowAttribute, hWnd,  #DWMWA_EXTENDED_FRAME_BOUNDS, wr.RECT, SizeOf(wr))       
                  EndIf
                  shadow = initshadow
                Else
                  shadow = 0
                  GetWindowRect_(hWnd, wr.RECT)
                EndIf                   
              EndIf                 
              CloseLibrary(Lib)                 
            Else
              shadow = 0
              GetWindowRect_(hWnd, wr.RECT)
            EndIf
          Else
            shadow = 0
            GetWindowRect_(hWnd, wr.RECT)
          EndIf;OSver
          If Themed = 1
            hBitmap = CreateImage(0,wr\right-wr\left+2*shadow,wr\bottom-wr\top+2*shadow,32,#PB_Image_Transparent )
          Else
            hBitmap = CreateImage(0,wr\right-wr\left+2*shadow,wr\bottom-wr\top+2*shadow)
          EndIf
          hdc = StartDrawing(ImageOutput(0))
          SelectObject_(hdc, hBitmap)
          BitBlt_(hdc,0,0,wr\right-wr\left+2*shadow,wr\bottom-wr\top+2*shadow, GetDC_(0),wr\left-shadow,wr\top-shadow,#SRCCOPY |#CAPTUREBLT)
          StopDrawing()
          UsePNGImageEncoder()
          
          d.s=FormatDate("%yyyy-%mm-%dd,%hh_%ii_%ss", Date())
          
          If spa=""
            StandardFile$ = d+".png"   ; set initial file+path to display
                                       ; With next string we will set the search patterns ("|" as separator) for file displaying:
                                       ;  1st: "Text (*.txt)" as name, ".txt" and ".bat" as allowed extension
                                       ;  2nd: "PureBasic (*.pb)" as name, ".pb" as allowed extension
                                       ;  3rd: "All files (*.*) as name, "*.*" as allowed extension, valid for all files
            Pattern$ = "Portable Network Graphics (*.png)"
            Pattern = 0
            File$ = SaveFileRequester("Please choose file to save", StandardFile$, Pattern$, Pattern)
            If File$<>""
              spa=GetPathPart(File$)
            EndIf
          EndIf
          
          If spa<>""
            If SaveImage(0,spa+d+".png",#PB_ImagePlugin_PNG)
            Else
              MessageRequester("Print Screen","cannot write image",#PB_MessageRequester_Ok)
            EndIf
          EndIf
        Else
          MessageRequester("Print Screen","cannot find active window",#PB_MessageRequester_Ok)
        EndIf
        
      Case #PB_Event_SysTray
        If EventType() = #PB_EventType_RightClick 
          DisplayPopupMenu(0, WindowID(0)) 
        EndIf 
        ;EndIf 
        
      Case #PB_Event_Menu;If EventID = #PB_Event_Menu ; <<-- PopUp Event 
        Select EventMenu() 
          Case 2
            Quit = 1 
        EndSelect 
        
      Case #PB_Event_CloseWindow 
        Break
    EndSelect
    
  Until Quit = 1
  RemoveSysTrayIcon(1)
  UnregisterHotKey_(WindowID(0),2)
EndIf

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 19
; FirstLine = 7
; EnableXP
; UseIcon = prsc.ico
; Executable = prsc.exe
; CommandLine = D:\